package ru.dbotthepony.mc.otm.graph.storage

import ru.dbotthepony.mc.otm.graph.Graph6Node
import ru.dbotthepony.mc.otm.storage.IStorage

interface IStorageGraphNode {
	/**
	 * Return all providers that this cell can store. Or nothing, if it is not a storage.
	 *
	 * If you don't know what you are going to store, you may return nothing.
	 *
	 * If something pops up, call [storageGraph], and then, call [StorageNetworkGraph.add].
	 */
	fun fetchComponents(): Collection<IStorage<*>>

	val storageNode: Graph6Node<IStorageGraphNode>
	val storageGraph: StorageNetworkGraph? get() = storageNode.graph as StorageNetworkGraph?
}
